"use strict";

var _require = require('./payload'),
    Payload = _require.Payload;

var _require2 = require('./utils'),
    isFunction = _require2.isFunction;

function Handler(cb) {
  if (!isFunction(cb)) {
    throw new TypeError('[[Handler]] first argument must be a Function. [Handler(cb)]');
  }

  return function (payload) {
    if (!Payload.isPayload(payload)) {
      throw new TypeError('handler argument type must be a [[Payload]] class objects');
    }

    cb(payload);
  };
}

module.exports = {
  Handler: Handler
};